<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="粮食种类" name="grainGroup">
						<a-select v-model:value="searchFormState.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="exportTable()">
						<export-outlined/>
						导出
					</a-button>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotGrainInfoPriceAdd')">
					</a-button>
					<a-button danger @click="deleteBatchDepotGrainInfoPrice()" v-if="hasPerm('depotGrainInfoPriceBatchDelete')"></a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<template v-if="hasPerm('关联主流价格')">
						<a @click="zoneFormRef.onOpen(record)">关联主流价格</a>
						<br>
					</template>
					<a @click="formRef.onOpen(record)" v-if="hasPerm('depotGrainInfoPriceEdit')">编辑</a>
					<a-divider type="vertical" v-if="hasPerm(['depotGrainInfoPriceEdit', 'depotGrainInfoPriceDelete'], 'and')"/>
					<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotGrainInfoPrice(record)">
						<a-button type="link" danger size="small" v-if="hasPerm('depotGrainInfoPriceDelete')">删除</a-button>
					</a-popconfirm>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<ZoneForm ref="zoneFormRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotGrainInfoPrice">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import ZoneForm from './zoneForm.vue'
import depotGrainInfoPriceApi from '@/api/biz/depotGrainInfoPriceApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const zoneFormRef = ref()
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const depotOptions = ref([])
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '粮食种类',
		dataIndex: 'grainGroup'
	},
	{
		title: '库存数量(万吨)',
		dataIndex: 'loanTonW'
	},
	{
		title: '默认干粮价格(元/吨)',
		dataIndex: 'dryPrice'
	},
	{
		title: '质押价格(元/吨)',
		dataIndex: 'loanPrice'
	},
	{
		title: '平均质押价格(元/吨)',
		dataIndex: 'loanPriceAvg'
	},
	{
		title: '质押率(%)',
		dataIndex: 'loanRatio'
	},
	{
		title: '潮干比',
		dataIndex: 'dampRatio'
	},
	{
		title: '干粮水份(%)',
		dataIndex: 'canonRatio'
	},
	{
		title: '关联主流价格',
		dataIndex: 'zonePrice'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotGrainInfoPriceEdit', 'depotGrainInfoPriceDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotGrainInfoPriceApi.depotGrainInfoPricePage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotGrainInfoPrice = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotGrainInfoPriceApi.depotGrainInfoPriceDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotGrainInfoPrice = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotGrainInfoPriceApi.depotGrainInfoPriceDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '库存数量(万吨)', '粮食种类', '默认干粮价格', '质押价格', '平均质押价格', '质押率(%)', '潮干比'
		, '干粮水份(%)', '关联主流价格(元/吨)']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.loanTonW, m.grainGroup, m.dryPrice, m.loanPrice, m.loanPriceAvg, m.loanRatio, m.dampRatio
				, m.canonRatio, m.zonePrice])
	})
	let bookNew = XLSX.utils.book_new()
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '粮食种类价格' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)

}
const grainGroupOptions = tool.dictList('粮食种类')
</script>
